#xp.py
#By: J3ff Hoogland
#Contact: blue_starsoar@yahoo.com
#Homepage: www.dndsource.net
#ES Homepage: mattie.info/cs/

import es
#Create Values that Determin how much xp a user gets for a kill, headshot, and knife kill
killxp = 50
headshotxp = 40
knifexp = 80
levelinterval = 300
#Runs when the mod is loaded, loads the keygroup 'xp' that stores all the user information
def load():
	if not es.exists('keygroup', 'xp'):
		es.keygroupload('xp', '|xp')
#Runs when ever a player joins the server
def player_activate(event_var):
	#Check to see if the user already has a key in the group
	if not es.exists('key', 'xp', str(event_var["es_steamid"])):
		#If they don't it goes to here and the creates them a key that is their steamid
		es.keycreate('xp', str(event_var["es_steamid"]))
		#Set's their xp value to 0
		es.keysetvalue('xp', str(event_var["es_steamid"]), 'xp', '0')
		#Set's their level to 0
		es.keysetvalue('xp', str(event_var["es_steamid"]), 'level', '1')
#Runs when ever a player dies
def player_death(event_var):
	#Checks to make sure the user's are on different teams
	if int(event_var['es_userteam']) != int(event_var['es_attackerteam']):
		#Checks to make sure it was not a world kill(IE Falling off a cliff)
		if str(event_var['weapon']) != 'world':
			#Make the killxp value == the global killxp value which we set at the top
			global killxp
			#Run the piece of code givexp with the attacker's id as the arg. and the killxp value as the second
			givexp(int(event_var["attacker"]), killxp)
			#Tell the user they scored a kill
			es.tell(int(event_var["attacker"]), '#multi', '#green You have gain #lightgreen %d #default Xp #green for scoring a kill.' % killxp)
			#Checks to see if the kill was a head shot
			if int(event_var['headshot']) == 1:
				#If head == true(or 1) then repeat xp giving process only with the headshotxp value
				global headshotxp
				givexp(int(event_var["attacker"]), headshotxp)
				es.tell(int(event_var["attacker"]), '#multi', '#lightgreen You have gain #default %d #green Xp #lightgreen for killing with a headshot.' % headshotxp)
			#Checks what weapon was used to score the kill
			if str(event_var['weapon']) == 'knife':
				#If it was a knife it runs this xp code
				global knifexp
				givexp(int(event_var["attacker"]), knifexp)
				es.tell(int(event_var["attacker"]), '#multi', '#default You have gain #green %d #lightgreen Xp #default for scoring a kill.' % knifexp)
#At round_end save the keygroup containing everyone's Xp
def round_end(event_var):
	es.keygroupsave('xp', '|xp')
#Runs when ever a player types something in chat
def player_say(event_var):
	#checks what the text was
	if str(event_var['text']) == 'xp':
		#if the text == xp then it runs this code
		#Gets the user's xp
		xp = int(es.keygetvalue('xp', str(event_var["es_steamid"]), 'xp'))
		#gets the user's level
		level = int(es.keygetvalue('xp', str(event_var["es_steamid"]), 'level'))
		#finds the global value of 'levelinterval'
		global levelinterval
		#uses a math functions to determin how much xp is need to gain a level
		xpneeded = int(levelinterval * level)
		xpneeded -= xp
		#tell the user their level, xp, and how much then need for another level
		es.tell(int(event_var["userid"]), '#multi', '#default You are Level : %d #lightgreen You have %d Xp. #green You need %d more xp to gain a level.' % (level, xp, xpneeded))
#The block that passes the information for giving a user Xp
#When the block is run the first arg. needs to be the userid, and then the second is the amount of xp given
def givexp(userid, amount):
	#Gets the users steamid
	steamid = str(es.getplayersteamid(userid))
	#Gets the users current xp value
	xp = int(es.keygetvalue('xp', steamid, 'xp'))
	#Gets the users level
	level = int(es.keygetvalue('xp', steamid, 'level'))
	#Adds the amount to the current xp
	xp = int(xp + amount)
	#Find the global value of levelinterval
	global levelinterval
	#Math fn. to find the xp needed till the next level
	xpneeded = int(levelinterval * level)
	if xp >= xpneeded:
		#If there is enough xp to level run this code
		#Take away the xp needed to level from the xp the user has
		xp = xp - xpneeded
		#Add one to their level
		level += 1
		#Store their new level
		es.keysetvalue('xp', steamid, 'level', level)
		#Tell the user they leveled
		es.tell(userid, '#multi', '#green You have advanced to #default Level #lightgreen %d' % level)
	#Store the user's new Xp value
	es.keysetvalue('xp', steamid, 'xp', xp)
#When you unload the mod this is run
def unload():
	#Removes extra key groups
	es.keygroupdelete('xp')